! /bin/bash
# Script to generate SSL certificates signed by private CA
# We need this to avoid browser wornings accessing intranet
# websites vi SSL
# this ist bases on https://gist.github.com/Soarez/9688998
# and the comment from "MacCliF commented on 10 May 2020"
# who compressed the based tutorial to the necessary and
# added .cnf files to make everything easier
# As the CA has to be created only once I did not make a extra script
# to create the CA and you should refer to the referenced article

# 13.02.2024 added IP adress as alternate name
# select valid days default 370, can be modified

# first we need to get all information

today=`date '+%Y_%m_%d__%H_%M_%S'`;
echo -e "\033[1m"
echo -e "\033[31mYou are about generating a new server certficate"
echo -e "is that what you want, continue (y/N) \033[0m"
read ok
if [ "$ok"  != "y" ] ; then
	echo -e "\033[31mleaving script!\033[0m"
	exit 1
fi
echo -e "\033[1mYou will be ask all needed information\033[30m"
echo -e "\033[1m seperate host domain ip tld\033[30m"
echo -e "\033[1m optional valid days tld\033[30m"

read -e -p "Enter Servername: [i.e. test] " server_name

read -e -p "Enter Domain: [your_domain] " -i "your_domain" domain_name

read -e -p "Enter TLD: [cpuntry code] " -i "country code"  tld_name

read -e -p "Enter IP Address: [192.168.1.11] " -i "192.168.1.11"  ip_address

read -e -p "Enter days valid: [370]: " -i "370" valid_days

# check certificate exists
if test -f  "$server_name"_"$domain_name"_"$tld_name".crt ; then

echo  -e "Certificate for $server_name.$domain_name.$tld_name exists"
	echo -e "Leaving script!"
	exit 1
else
	echo ""
	echo "Filenames created will be"
	key_filename="$server_name"_"$domain_name"_"$tld_name".key
	echo "$key_filename"
	csr_filename="$server_name"_"$domain_name"_"$tld_name".csr
	echo "$csr_filename"
	crt_filename="$server_name"_"$domain_name"_"$tld_name".crt
	echo "$crt_filename"
	req_filename=req."$server_name"_"$domain_name"_"$tld_name".cnf
	echo "$req_filename"
	bundle_filename="$server_name"_"$domain_name"_"$tld_name".bundle.crt
	echo "$bundle_filename"
	host_name="$server_name"."$domain_name"."$tld_name"
	full_info="$server_name"."$domain_name"."$tld_name"' with IP: '"$ip_address"' valid_for: '"$valid_days"' days'
	echo " "
	echo -e "Full certificate created information is:"
	echo $full_info
	echo " "
	echo "correct? [y/N]"
	read ok
	if [ "$ok"  != "y" ] ; then
		echo -e "Leaving script!"
		exit 1
	else
		echo -e "Continue createing certificate"
	fi
fi
echo "you will asked twice at the end, just accept with "y"!"
echo [ req ] > ./$req_filename
echo default_bits = 2048 >> ./$req_filename
echo default_keyfile = "$key_filename" >> ./$req_filename
echo encrypt_key = no >> ./$req_filename
echo default_md = sha256 >> ./$req_filename
echo prompt = no >> ./$req_filename
echo utf8 = yes >> ./$req_filename
echo distinguished_name = my_req_distinguished_name >> ./$req_filename
echo [ my_req_distinguished_name ] >> ./$req_filename
echo C=COUNTRY_CODE >> ./$req_filename
echo ST=REGION >> ./$req_filename
echo L=CITY >> ./$req_filename
echo O=COMPANY >> ./$req_filename
echo OU=DEPARTMENT >> ./$req_filename
echo CN="$host_name" >> ./$req_filename
echo [ my_extensions ] >> ./$req_filename
echo keyUsage=critical, digitalSignature, keyEncipherment >> ./$req_filename
echo basicConstraints=critical,CA:FALSE >> ./$req_filename
echo extendedKeyUsage=critical,serverAuth >> ./$req_filename
echo subjectAltName=@my_subject_alt_names >> ./$req_filename
echo subjectKeyIdentifier = hash >> ./$req_filename
echo [ my_subject_alt_names ] >> ./$req_filename
echo DNS.1 = "$host_name" >> ./$req_filename
# if IP = default weglassen
echo IP.1 = "$ip_address" >> ./$req_filename

echo "create CSR file"
#echo openssl req -new -out $csr_filename -config $req_filename
openssl req -new -out $csr_filename -config $req_filename

echo "create CRT file"
echo openssl ca -config sign.ca.cnf -extfile $req_filename -extensions my_extensions -out $crt_filename -infiles $csr_filename > result.txt

echo "sign now"
openssl ca -config sign.ca.cnf -extfile $req_filename -extensions my_extensions -out $crt_filename -infiles $csr_filename

echo "create bundle"
cat $crt_filename your_ca.crt > $bundle_filename

echo "you have successfully created a CA signed certificate for $host_name"
echo "IMPORTANT it will expire in "
echo $valid_days
echo "from now"
echo "remember to renew with provided script rewnew_cert.sh"