#!/bin/bash
echo -e "Convert crt to pem, der ? (y/N)"
read ok
if [  "$ok"  != "y" ] ; then
	echo -e "Leaving script!"
	exit 1
fi
echo -e "Enter Certname:"
read certname
echo -e "$certname OK (y/N)"
read ok
if [ "$ok" != "y" ] ; then
	echo -e "Leaving script!"
	exit 1
fi
if [ ! -f "$certname.key" ] ; then
	echo -e "no such files $certname.*, leave!"
	exit 1
fi

echo -e "Move to subdir ? (y/N)"
read ok
if [ "$ok" == "y" ] ; then
	echo -e "Enter Subdir name:"
	read sub
	echo -e "$sub OK ? (y/N)"
	read ok
	if [ "$ok" != "y" ] ; then
		echo -e "Leaving script"
		exit 1
	fi
fi
openssl x509 -in "$certname".crt -out "$certname".pem -outform PEM
openssl x509 -in "$certname".pem -out "$certname".cer -outform DER
cat "$certname".key "$certname".pem > "$certname".key.pem
openssl x509 -in "$certname".key.pem -out "$certname".key.cer -outform DER
echo -e "Check if variable sub exsits"
if ${sub+"false"} ; then
	echo -e "variable sub unset"
	ls -la "$certname".*
else
	echo -e "variable sub is set"
	if [  ! -d "$sub" ]; then
		echo -e "subdir does not exist create it"
		mkdir "$sub"
	else
		echo -e "subdir exists"
	fi
	echo -e "move files"
	mv "$certname".* "$sub"
	cd "$sub"
	ls -la "$certname".*
	cd ..
fi
