#! /bin/bash
# Script to renew SSL certificates signed by private CA
# We need this to renew our expired certificates


# first we need to get all information
today=`date '+%Y_%m_%d__%H_%M_%S'`;
echo -e "\033[1m"
echo -e "\033[31mYou are about to renew an existing server certficate"
echo -e "\033[31mthat is expired or will expire soon"
echo -e "\033[31mIMPORTANT existing certificates for this server will be overridden"
echo -e "is that what you want, continue (y/N) \033[0m"
read ok
if [ "$ok"  != "y" ] ; then
	echo -e "\033[31mleaving script!\033[0m"
	exit 1
fi
echo -e "\033[1mYou will be ask all needed information\033[30m"
echo -e "\033[1mseparate for host, domain, tld\033[30m"
echo -e "\033[1mEnter Servername: [test]\033[30m"
read server_name
# echo -e "\033[1myou entered \033[32m$server_name\033[30m"
echo -e "\033[1mEnter Domain: [example]\033[30m"
read domain_name
# echo -e "\033[1myou entered \033[32m$domain_name\033[30m"
echo -e "\033[1mEnter TLD: [org]\033[30m"
read tld_name
#echo -e "\033[1myou entered \033[32m$tld_name\033[30m"
# check certificate exists
if test -f  "$server_name"_"$domain_name"_"$tld_name".crt ; then
	echo  -e "\033[31m Certificate for '$server_name'.'$domain_name'.$tld_name' exists\033[30m"
else
	echo -e "\033[31mNo existing certificate, leaving script!\033[0m"
	exit 1
fi
echo ""
echo "Filenames created will be"
key_filename="$server_name"_"$domain_name"_"$tld_name".key
echo "$key_filename"
crt_filename="$server_name"_"$domain_name"_"$tld_name".crt
echo "$crt_filename"
req_filename=req."$server_name"_"$domain_name"_"$tld_name".cnf
echo "$req_filename"
csr_filename="$server_name"_"$domain_name"_"$tld_name".csr
echo $csr_filename
bundle_filename="$server_name"_"$domain_name"_"$tld_name".bundle.crt
echo "$bundle_filename"
host_name="$server_name"."$domain_name"."$tld_name"
echo -e "your full server name is:\033[32m"
echo "$host_name, is this the host, whos certificate should be renewed?"
echo -e "\033[0m"
echo "correct? [y/N]"
read ok
if [ "$ok"  != "y" ] ; then
	echo -e "\033[31mleaving script!\033[0m"
	exit 1
else
	echo -e "\033[31mcontinue renewing certificate\033[0m"
fi
echo "renewing certificate"
echo "you will be asked twice at the end, just accepti with "y"!"
openssl ca -config sign.ca.cnf -extfile $req_filename -extensions my_extensions -out $crt_filename -infiles $csr_filename
echo "create bundle"
cat $crt_filename your_ca.crt > $bundle_filename

echo "you have successfully created an certificate with the old key"
echo "you just have to replace the certificate and if used the bundle"
echo "the new certificate will valid one year from now"
